// Cyberdlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxcmn.h>
#include <afxwin.h>
#include "CyberTrak.h"
#include "Cyberdlg.h"
#include "MaxxCom.h"
#include "helpdlg.h"	

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog()
{

	CDialog::OnInitDialog();
	CenterWindow();
	 
	// TODO: Add extra about dlg initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CCyberTrakDlg dialog

CCyberTrakDlg::CCyberTrakDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCyberTrakDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCyberTrakDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCyberTrakDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCyberTrakDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCyberTrakDlg, CDialog)
	//{{AFX_MSG_MAP(CCyberTrakDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABOUT_US, OnAboutUs)
	ON_BN_CLICKED(IDC_HELP_ME, OnHelpMe)
	ON_BN_CLICKED(IDC_PULL_PORT, OnPullPort)
	ON_BN_CLICKED(IDC_19200, On19200)
	ON_BN_CLICKED(IDC_9600, On9600)
	ON_BN_CLICKED(IDC_AVR_FIL_OFF, OnAvrFilOff)
	ON_BN_CLICKED(IDC_AVR_FIL_ON, OnAvrFilOn)
	ON_BN_CLICKED(IDC_CHECK_OFF, OnCheckOff)
	ON_BN_CLICKED(IDC_CHECK_ON, OnCheckOn)
	ON_BN_CLICKED(IDC_COM1, OnCom1)
	ON_BN_CLICKED(IDC_COM2, OnCom2)
	ON_BN_CLICKED(IDC_COM3, OnCom3)
	ON_BN_CLICKED(IDC_COM4, OnCom4)
	ON_BN_CLICKED(IDC_HARD_RESET, OnHardReset)
	ON_BN_CLICKED(IDC_HYSTER_OFF, OnHysterOff)
	ON_BN_CLICKED(IDC_HYSTER_ON, OnHysterOn)
	ON_EN_CHANGE(IDC_SAMPLE_INPUT, OnChangeSampleInput)
	ON_BN_CLICKED(IDC_ASCII, OnSetToAscii)
	ON_BN_CLICKED(IDC_BINARY, OnSetToBinary)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CONTINOUS, OnSetToContinous)
	ON_BN_CLICKED(IDC_UPON_REQUEST, OnUponRequest)
	ON_BN_CLICKED(IDC_START, OnStartSampling)
	ON_BN_CLICKED(IDC_STOP, OnStopSampling)
	ON_BN_CLICKED(IDOK, OnOKExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCyberTrakDlg message handlers

BOOL CCyberTrakDlg::OnInitDialog()
{	
	CDialog::OnInitDialog();
	CenterWindow();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// TODO: Add extra initialization here
	// My init
	// Used in MessageBox Dlg

    CheckRadioButton( IDC_ASCII, IDC_BINARY, IDC_BINARY);
	CheckRadioButton( IDC_CHECK_ON, IDC_CHECK_OFF, IDC_CHECK_OFF);
	CheckRadioButton( IDC_UPON_REQUEST, IDC_CONTINOUS, IDC_UPON_REQUEST);
	CheckRadioButton( IDC_AVR_FIL_ON, IDC_AVR_FIL_OFF, IDC_AVR_FIL_ON);
	CheckRadioButton( IDC_HYSTER_ON, IDC_HYSTER_OFF, IDC_HYSTER_OFF);
	CheckRadioButton( IDC_9600, IDC_19200, IDC_9600);

	CSpinButtonCtrl* rateButton;
  	rateButton = (CSpinButtonCtrl*)GetDlgItem(IDC_SAMPLE);
	rateButton->SetRange(MINPACK,MAXPACK);
	UDACCEL acc;
	acc.nInc = 5;
	rateButton->SetAccel(1,&acc);
  	SetDlgItemText(IDC_SAMPLE_INPUT, DEFSAMPLE);

  	BOOL Result;

	if((Result = ComPort.AutoDetectComPort(m_hWnd)) == TRUE)
		  ComPort.Get_Version(m_hWnd);
	 
	CButton* button = (CButton*) GetDlgItem(IDC_STOP);
	button->EnableWindow(FALSE);
	button = (CButton*) GetDlgItem(IDC_START);
	button->EnableWindow(FALSE);

	timerID = 1;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCyberTrakDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCyberTrakDlg::OnPaint() 
{
	CRect rect;
	GetClientRect(&rect);
	int x = rect.Width();
	int y = rect.Height();

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		x -= (cxIcon + 1) / 2;
		y -= (cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

      CPaintDC dc( this ); // Device context for painting
 
      CBitmap bmp, *poldbmp;
      CDC memdc;


		if( x <= 429 && y <= 354){		   // System is Set to Small fonts
					// Load the Small bitmap resource
			  bmp.LoadBitmap( IDB_BITMAP2 );
					// Create a compatible memory DC
			  memdc.CreateCompatibleDC( &dc );	
					// Select the bitmap into the DC
			  poldbmp = memdc.SelectObject( &bmp );
 					// Copy (BitBlt) bitmap from memory DC to screen DC
 			  dc.BitBlt( 25, 118, 128, 55, &memdc, 0, 0, SRCCOPY );	   // small fonts
			  memdc.SelectObject( poldbmp );
		}
		else {			// System set to Large fonts
 					  // Load the Small bitmap resource
			  bmp.LoadBitmap( IDB_BITMAP1 );
					// Create a compatible memory DC
			  memdc.CreateCompatibleDC( &dc );	
					// Select the bitmap into the DC
			  poldbmp = memdc.SelectObject( &bmp );
 					// Copy (BitBlt) bitmap from memory DC to screen DC
			  dc.BitBlt( 29, 145,167, 66, &memdc, 0, 0, SRCCOPY );  // Large fonts
			  memdc.SelectObject( poldbmp );
		}
      // Do not call CDialog::OnPaint() for painting message
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCyberTrakDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCyberTrakDlg::OnAboutUs() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();	
}

void CCyberTrakDlg::OnHelpMe() 
{
	// TODO: Add your control notification handler code here
	HelpDlg	dlgHelp;
	dlgHelp.DoModal();
}

void CCyberTrakDlg::OnPullPort()
{
 ComPort.PullPort(m_hWnd);	 
}

void CCyberTrakDlg::On19200() 
{
		SetDlgItemText(IDC_CHECKMSG, COM19200);
}

void CCyberTrakDlg::On9600() 
{
		SetDlgItemText(IDC_CHECKMSG, COM9600);
}

void CCyberTrakDlg::OnAvrFilOff() 
{

	SetDlgItemText(IDC_CHECKMSG,AVFILTEROFF);
}

void CCyberTrakDlg::OnAvrFilOn() 
{

	SetDlgItemText(IDC_CHECKMSG,AVFILTERENB);
}

void CCyberTrakDlg::OnCheckOff() 
{
	ComPort.CheckSumOff();
	SetDlgItemText(IDC_CHECKMSG,CHECKOFF);	
}	// end of CheckSumOff

void CCyberTrakDlg::OnCheckOn() 
{
	ComPort.CheckSumOn();
	SetDlgItemText(IDC_CHECKMSG,CHECKENB);	
}	// end of ChackSumOn

void CCyberTrakDlg::OnCom1() 
{
 int Speed, Pid;
  if( (Pid = ComPort.GetPortId()) == COM1_ID){
      SetDlgItemText(IDC_CHECKMSG, SELERROR);
      return;
	}
	  ComPort.SetTempComHandle();
	  if( (Speed = ComPort.GetCurrentSpeed()) == 9600);

 if( ComPort.OpenCom(COM1))	   // New found!!!
 	if( ComPort.CheckIfBusy()){
		ComPort.CloseCom( ComPort.GetTempComHandle());
		ComPort.SetPortId(COM1_ID);
		ComPort.Get_Version(m_hWnd);
		SetDlgItemText(IDC_CHECKMSG,MAXFOUND);
		return;
	}	
 ComPort.SetNewComHandle();
 ComPort.SetSpeedFlag(Speed); // Set original Speed
  ComPort.SetPortId(Pid);	  // Set to Previous
 SetDlgItemText(IDC_CHECKMSG, COM1ERR);	
}	// end of OnCom1

void CCyberTrakDlg::OnCom2() 
{
 int Speed,Pid;
  if( (Pid=ComPort.GetPortId()) == COM2_ID){
      SetDlgItemText(IDC_CHECKMSG, SELERROR);
      return;
	}
      ComPort.SetTempComHandle();
	  if( (Speed = ComPort.GetCurrentSpeed()) == 9600);

 if( ComPort.OpenCom(COM2))	   // New found!!!
 	if( ComPort.CheckIfBusy()){
		ComPort.CloseCom( ComPort.GetTempComHandle());
		ComPort.SetPortId(COM2_ID);
		ComPort.Get_Version(m_hWnd);
		SetDlgItemText(IDC_CHECKMSG,MAXFOUND);
		return;
	}
 ComPort.SetNewComHandle();
 ComPort.SetSpeedFlag(Speed); // Set original Speed
  ComPort.SetPortId(Pid);	  // Set to Previous
 SetDlgItemText(IDC_CHECKMSG, COM2ERR);  	
}	// end of OnCom2
									

void CCyberTrakDlg::OnCom3() 
{
 int Speed, Pid;
  if( (Pid = ComPort.GetPortId()) == COM3_ID){
      SetDlgItemText(IDC_CHECKMSG, SELERROR);
      return;
	}
      ComPort.SetTempComHandle();
	  if( (Speed = ComPort.GetCurrentSpeed()) == 9600);

 if( ComPort.OpenCom(COM3))	   // New found!!!
 	if( ComPort.CheckIfBusy()){
		ComPort.CloseCom( ComPort.GetTempComHandle());
		ComPort.SetPortId(COM3_ID);
		ComPort.Get_Version(m_hWnd);
		SetDlgItemText(IDC_CHECKMSG,MAXFOUND);
		return;
	}
 ComPort.SetNewComHandle();
 ComPort.SetSpeedFlag(Speed); // Set original Speed
  ComPort.SetPortId(Pid);	  // Set to Previous
 SetDlgItemText(IDC_CHECKMSG, COM3ERR);	
}	// end of OnCom3


void CCyberTrakDlg::OnCom4() 
{
 int Speed,Pid;
  if( (Pid = ComPort.GetPortId()) == COM4_ID){
      SetDlgItemText(IDC_CHECKMSG, SELERROR);
      return;
	}
      ComPort.SetTempComHandle();
	  if( (Speed = ComPort.GetCurrentSpeed()) == 9600);

 if( ComPort.OpenCom(COM4))	   // New found!!!
 	if( ComPort.CheckIfBusy()){
		ComPort.CloseCom( ComPort.GetTempComHandle());
		ComPort.SetPortId(COM4_ID);
		ComPort.Get_Version(m_hWnd);
		SetDlgItemText(IDC_CHECKMSG,MAXFOUND);
		return;
	}
 ComPort.SetNewComHandle();
 ComPort.SetSpeedFlag(Speed); // Set original Speed
 ComPort.SetPortId(Pid);	  // Set to Previous
 SetDlgItemText(IDC_CHECKMSG, COM4ERR);	
}	// end of OnCom4
		  
void CCyberTrakDlg::OnHardReset() 
{
	if( ComPort.HardReset() ){
	 SetDlgItemText(IDC_OUTPUT, " ");
	 SetDlgItemText(IDC_X, " ");
	 SetDlgItemText(IDC_Y, " ");
	 SetDlgItemText(IDC_Z, " ");

	 if(ComPort.getTransMode() == *CONTINOUS_SAMPLE_MODE)
	 KillTimer(timerID);

	 ComPort.SetSamplingRate( atoi(DEFSAMPLE ));
	 SetDlgItemText(IDC_SAMPLE_INPUT, DEFSAMPLE);
	 SetDlgItemText(IDC_CHECKMSG, HARDOK);

	 CButton* button = (CButton*) GetDlgItem(IDC_PULL_PORT);
		button->EnableWindow(TRUE);
		button = (CButton*) GetDlgItem(IDC_STOP);
		button->EnableWindow(FALSE);
		button = (CButton*) GetDlgItem(IDC_START);
		button->EnableWindow(FALSE);
	 return;
	}
	SetDlgItemText(IDC_CHECKMSG, HARDERR);	
}	// end of OnHardReset

void CCyberTrakDlg::OnHysterOff() 
{
	ComPort.setHysteresisOff();
	SetDlgItemText(IDC_CHECKMSG, HYSTEROFF);
}	// end of OnHysteresisOff

void CCyberTrakDlg::OnHysterOn() 
{
	ComPort.setHysteresisOn();
	SetDlgItemText(IDC_CHECKMSG, HYSTERON);
}	// end of OnHysteresisOn

void CCyberTrakDlg::OnChangeSampleInput() 
{
	CString strFoo;
	GetDlgItemText( IDC_SAMPLE_INPUT, strFoo );
	ComPort.SetSamplingRate( atoi(strFoo) );

}

void CCyberTrakDlg::OnSetToAscii() 
{
	ComPort.setDataMode(*ASCII_MODE);
	ComPort.ResetFIFO();
	ComPort.SendToPort(ASCII_MODE);
	CButton* button = (CButton*) GetDlgItem(IDC_CHECK_ON);
	button->EnableWindow(FALSE);
	button = (CButton*) GetDlgItem(IDC_CHECK_OFF);
	button->EnableWindow(FALSE);
}

void CCyberTrakDlg::OnSetToBinary() 
{
	ComPort.setDataMode(*BINARY_MODE);
	ComPort.ResetFIFO();
	ComPort.SendToPort(BINARY_MODE);
	CButton* button = (CButton*) GetDlgItem(IDC_CHECK_ON);
	button->EnableWindow(TRUE);
	button = (CButton*) GetDlgItem(IDC_CHECK_OFF);
	button->EnableWindow(TRUE);
}

void CCyberTrakDlg::OnSetToContinous() 
{
	ComPort.SetSamplingRate( ComPort.getSamplingRate() );
	ComPort.setTransMode(*CONTINOUS_SAMPLE_MODE);
	ComPort.ResetFIFO();
	ComPort.SendToPort(CONTINOUS_SAMPLE_MODE);

	CButton* button = (CButton*) GetDlgItem(IDC_PULL_PORT);
	button->EnableWindow(FALSE);
	button = (CButton*) GetDlgItem(IDC_STOP);
	button->EnableWindow(TRUE);
	button = (CButton*) GetDlgItem(IDC_START);
	button->EnableWindow(TRUE);
}

void CCyberTrakDlg::OnUponRequest() 
{
	if(ComPort.getTransMode() == *CONTINOUS_SAMPLE_MODE)
	 KillTimer(timerID);
	ComPort.SendToPort(SAMPLE_UPON_REQUEST);
	Sleep(20);
	ComPort.ResetFIFO();
	ComPort.setTransMode(*SAMPLE_UPON_REQUEST);

	CButton* button = (CButton*) GetDlgItem(IDC_PULL_PORT);
	button->EnableWindow(TRUE);
	button = (CButton*) GetDlgItem(IDC_STOP);
	button->EnableWindow(FALSE);
	button = (CButton*) GetDlgItem(IDC_START);
	button->EnableWindow(FALSE);
}

void CCyberTrakDlg::OnStartSampling() 
{										
	SetTimer(timerID, 13, NULL);
}

void CCyberTrakDlg::OnStopSampling() 
{
	KillTimer(timerID);
}

void CCyberTrakDlg::OnTimer(UINT nIDEvent) 
{
	ComPort.ReadFromPort(FALSE);	// FALSE in sampled_upon_request
	ComPort.UpdateScreen( m_hWnd);
	
	CDialog::OnTimer(nIDEvent);
}

void CCyberTrakDlg::OnOKExit() 
{
ComPort.CloseCom(ComPort.GetComHandle());	
 CDialog::OnOK();
}
